﻿Public Class Form_Oitavas

    Dim selid As Integer
    Dim jgs As Integer
    Dim pts As Integer
    Dim vit As Integer
    Dim emp As Integer
    Dim der As Integer
    Dim gp As Integer
    Dim gc As Integer
    Dim sg As Integer

    Private Sub FormOitavas_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        preencheGrid(9)
    End Sub
    Private Sub preencheGrid(ByVal grupo As Integer)

        Dim lblDatas() As Label = New Label() {lblData1, lblData2, lblData3, lblData4, lblData5, lblData6, lblData7, lblData8}
        Dim lblHoras() As Label = New Label() {lblHora1, lblHora2, lblHora3, lblHora4, lblHora5, lblHora6, lblHora7, lblHora8}
        Dim lblSelecoes1() As Label = New Label() {lblSelecao11, lblSelecao12, lblSelecao13, lblSelecao14, lblSelecao15, lblSelecao16, lblSelecao17, lblSelecao18}
        Dim picBandeiras1() As PictureBox = New PictureBox() {picBandeiraSelecao11, picBandeiraSelecao12, picBandeiraSelecao13, picBandeiraSelecao14, picBandeiraSelecao15, picBandeiraSelecao16, picBandeiraSelecao17, picBandeiraSelecao18}
        Dim txtGol1s() As TextBox = New TextBox() {txtGol11, txtGol12, txtGol13, txtGol14, txtGol15, txtGol16, txtGol17, txtGol18}
        Dim txtGol2s() As TextBox = New TextBox() {txtGol21, txtGol22, txtGol23, txtGol24, txtGol25, txtGol26, txtGol27, txtGol28}
        Dim picBandeiras2() As PictureBox = New PictureBox() {picBandeiraSelecao21, picBandeiraSelecao22, picBandeiraSelecao23, picBandeiraSelecao24, picBandeiraSelecao25, picBandeiraSelecao26, picBandeiraSelecao27, picBandeiraSelecao28}
        Dim lblSelecoes2() As Label = New Label() {lblSelecao21, lblSelecao22, lblSelecao23, lblSelecao24, lblSelecao25, lblSelecao26, lblSelecao27, lblSelecao28}
        Dim i As Integer = 0

        Using ctx As New Copa2014Entities
            Try
                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupo
                            Select jg

                If jogos.Count = 8 Then
                    For Each jogo In jogos
                        lblDatas(i).Text = jogo.Data
                        lblHoras(i).Text = jogo.Hora.ToString
                        lblSelecoes1(i).Text = jogo.Selecoes.NomeSelecao
                        picBandeiras1(i).Image = exibeBandeira(jogo.Selecoes.Bandeira)
                        txtGol1s(i).Text = jogo.Gol1
                        txtGol2s(i).Text = jogo.Gol2
                        picBandeiras2(i).Image = exibeBandeira(jogo.Selecoes1.Bandeira)
                        lblSelecoes2(i).Text = jogo.Selecoes1.NomeSelecao
                        i = i + 1
                    Next
                Else
                    MessageBox.Show("Não há jogos cadastrados/ou faltam jogos para este grupo. Cadastre os jogos antes...")
                    Me.Close()
                End If

            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Function exibeBandeira(ByVal nomeArquivo As String) As Bitmap
        Try
            Dim bm As New Bitmap(nomeArquivo)
            Return bm
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Sub btnResultadoOitavas_Click(sender As Object, e As EventArgs) Handles btnResultadoOitavas.Click
        atualizaJogosOitavas(9)
        atualizaClassificacaoOitavas(9)
    End Sub
    Private Sub atualizaJogosOitavas(ByVal grupo As Integer)

        Dim txtGol1s() As TextBox = New TextBox() {txtGol11, txtGol12, txtGol13, txtGol14, txtGol15, txtGol16, txtGol17, txtGol18}
        Dim txtGol2s() As TextBox = New TextBox() {txtGol21, txtGol22, txtGol23, txtGol24, txtGol25, txtGol26, txtGol27, txtGol28}

        Dim i As Integer = 0
        Using ctx As New Copa2014Entities
            Try
                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupo
                            Select jg

                If jogos.Count = 8 Then
                    For Each jogo In jogos.ToList
                        'atualiza os controles do formulário
                        jogo.Gol1 = txtGol1s(i).Text
                        jogo.Gol2 = txtGol2s(i).Text
                        ctx.SaveChanges()
                        i = i + 1
                    Next
                    MessageBox.Show("Resultado atualizado com Sucesso", "Atualizado", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    MessageBox.Show("Não há jogos cadastrados para este grupo. Cadastre os jogos antes...")
                End If
            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Sub atualizaClassificacaoOitavas(ByVal grupoAtual As Integer)

        Dim selid As Integer

        Using ctx As New Copa2014Entities
            Try
                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupoAtual
                            Select jg
             
                For Each jogo In jogos.ToList
                    'zera valores para inicio da contagem
                    pts = 0
                    sg = 0
                    gp = 0
                    gc = 0
                    jgs = 1
                    vit = 0
                    emp = 0
                    der = 0
                    'calcula vitoria , empates e derrotas
                    If jogo.Gol1 > jogo.Gol2 Then
                        vit = vit + 1
                        gp = gp + jogo.Gol1
                        gc = gc + jogo.Gol2
                        selid = jogo.SelecaoId1
                        'calcula pontos e salgo de gols
                        pts = vit * 3 + emp * 1
                        sg = gp - gc
                        'atualiza classificacao
                        InserirAtualizarDadosClassificacao(grupoAtual, selid)
                        der = der + 1
                        vit = 0
                        gp = gp + jogo.Gol2
                        gc = gc + jogo.Gol1
                        selid = jogo.SelecaoId2
                        'calcula o salgo de gols
                        pts = vit * 3 + emp * 1
                        sg = gp - gc
                        InserirAtualizarDadosClassificacao(grupoAtual, selid)
                    ElseIf jogo.Gol2 > jogo.Gol1 Then
                        vit = vit + 1
                        gp = gp + jogo.Gol2
                        gc = gc + jogo.Gol1
                        selid = jogo.SelecaoId2
                        'calcula pontos e salgo de gols
                        pts = vit * 3 + emp * 1
                        sg = gp - gc
                        'atualiza classificacao
                        InserirAtualizarDadosClassificacao(grupoAtual, selid)
                        der = der + 1
                        vit = 0
                        gp = gp + jogo.Gol1
                        gc = gc + jogo.Gol2
                        selid = jogo.SelecaoId1
                        'calcula o salgo de gols
                        pts = vit * 3 + emp * 1
                        sg = gp - gc
                        InserirAtualizarDadosClassificacao(grupoAtual, selid)
                    End If
                Next
                'exibe classificacao
                exibeClassificacao(grupoAtual)
            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Sub InserirAtualizarDadosClassificacao(ByVal grupoId As Integer, ByVal selecaoid As Integer)

        Try
            Using ctx As New Copa2014Entities

                Dim classif = (From cla In ctx.Classificacao Where cla.SelecaoId = selecaoid).SingleOrDefault

                If IsNothing(classif) Then
                    Dim classificacao As New Classificacao
                    classificacao.SelecaoId = selecaoid
                    classificacao.GrupoId = grupoId
                    classificacao.Pontos = pts
                    classificacao.Jogos = jgs
                    classificacao.Vitorias = vit
                    classificacao.Empates = emp
                    classificacao.Derrotas = der
                    classificacao.GolPro = gp
                    classificacao.GolContra = gc
                    classificacao.SaldoGols = sg
                    ctx.Classificacao.Add(classificacao)
                    ctx.SaveChanges()
                Else
                    Try
                        classif.SelecaoId = selecaoid
                        classif.GrupoId = grupoId
                        classif.Pontos = pts
                        classif.Jogos = jgs
                        classif.Vitorias = vit
                        classif.Empates = emp
                        classif.Derrotas = der
                        classif.GolPro = gp
                        classif.GolContra = gc
                        classif.SaldoGols = sg
                        ctx.SaveChanges()
                    Catch ex As Exception
                        MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End Try
                End If

            End Using

        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir/Atualizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub exibeClassificacao(ByVal grupo As Integer)
        Using ctx As New Copa2014Entities
            Try
                Dim classificacao = (From clsf In ctx.Classificacao
                                    Where clsf.GrupoId = grupo
                                    Order By clsf.Pontos Descending, clsf.SaldoGols Descending, clsf.GolPro Descending
                                    Select clsf.Selecoes.NomeSelecao, clsf.Pontos, clsf.Jogos, clsf.Vitorias, clsf.Empates, clsf.Derrotas, clsf.GolPro, clsf.GolContra, clsf.SaldoGols).Take(8)

                dgvOitavas.DataSource = classificacao.ToList
                formataGridView()

            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Sub formataGridView()

        With dgvOitavas
            .AutoGenerateColumns = False
            .RowHeadersVisible = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera a cor das linhas alternadas no grid
            .RowsDefaultCellStyle.BackColor = Color.White
            .AlternatingRowsDefaultCellStyle.BackColor = Color.YellowGreen
            'altera o nome das colunas
            .Columns(0).HeaderText = "Classificação"
            .Columns(1).HeaderText = "P"
            .Columns(2).HeaderText = "J"
            .Columns(3).HeaderText = "V"
            .Columns(4).HeaderText = "E"
            .Columns(5).HeaderText = "D"
            .Columns(6).HeaderText = "GP"
            .Columns(7).HeaderText = "GC"
            .Columns(8).HeaderText = "SG"
            'largura colunas
            .Columns(0).Width = 150
            .Columns(1).Width = 50
            .Columns(2).Width = 50
            .Columns(3).Width = 50
            .Columns(4).Width = 50
            .Columns(5).Width = 50
            .Columns(6).Width = 50
            .Columns(7).Width = 50
            .Columns(8).Width = 50
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            ' exibe nulos formatados
            .DefaultCellStyle.NullValue = " - "
            'permite que o texto maior que célula não seja truncado
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
        End With

    End Sub
    Private Sub SAIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SAIRToolStripMenuItem.Click
        Me.Close()
    End Sub
End Class