USE [Copa2014]
GO

/****** Object:  Table [dbo].[Jogos]    Script Date: 05/06/2014 10:41:03 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Jogos](
	[JogoId] [int] IDENTITY(1,1) NOT NULL,
	[Data] [date] NULL,
	[Hora] [time](7) NULL,
	[LocalId] [int] NULL,
	[GrupoId] [int] NOT NULL,
	[SelecaoId1] [int] NOT NULL,
	[Gol1] [int] NOT NULL,
	[SelecaoId2] [int] NOT NULL,
	[Gol2] [int] NOT NULL,
 CONSTRAINT [PK_Jogos] PRIMARY KEY CLUSTERED 
(
	[JogoId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[Jogos]  WITH CHECK ADD  CONSTRAINT [FK_Jogos_Grupos] FOREIGN KEY([GrupoId])
REFERENCES [dbo].[Grupos] ([GrupoId])
GO

ALTER TABLE [dbo].[Jogos] CHECK CONSTRAINT [FK_Jogos_Grupos]
GO

ALTER TABLE [dbo].[Jogos]  WITH CHECK ADD  CONSTRAINT [FK_Jogos_Locais] FOREIGN KEY([LocalId])
REFERENCES [dbo].[Locais] ([LocalId])
GO

ALTER TABLE [dbo].[Jogos] CHECK CONSTRAINT [FK_Jogos_Locais]
GO

ALTER TABLE [dbo].[Jogos]  WITH CHECK ADD  CONSTRAINT [FK_Jogos_Selecoes] FOREIGN KEY([SelecaoId1])
REFERENCES [dbo].[Selecoes] ([SelecaoId])
GO

ALTER TABLE [dbo].[Jogos] CHECK CONSTRAINT [FK_Jogos_Selecoes]
GO

ALTER TABLE [dbo].[Jogos]  WITH CHECK ADD  CONSTRAINT [FK_Jogos_Selecoes1] FOREIGN KEY([SelecaoId2])
REFERENCES [dbo].[Selecoes] ([SelecaoId])
GO

ALTER TABLE [dbo].[Jogos] CHECK CONSTRAINT [FK_Jogos_Selecoes1]
GO


