USE [Copa2014]
GO

/****** Object:  Table [dbo].[Classificacao]    Script Date: 05/06/2014 10:40:19 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Classificacao](
	[ClassificacaoId] [int] IDENTITY(1,1) NOT NULL,
	[SelecaoId] [int] NOT NULL,
	[GrupoId] [int] NOT NULL,
	[Jogos] [int] NULL,
	[Vitorias] [int] NULL,
	[Empates] [int] NULL,
	[Derrotas] [int] NULL,
	[GolPro] [int] NULL,
	[GolContra] [int] NULL,
	[SaldoGols] [int] NULL,
	[Pontos] [int] NULL,
	[Sorteio] [int] NULL,
 CONSTRAINT [PK_Classificacao] PRIMARY KEY CLUSTERED 
(
	[ClassificacaoId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[Classificacao] ADD  CONSTRAINT [DF_Classificacao_Sorteio]  DEFAULT ((0)) FOR [Sorteio]
GO

ALTER TABLE [dbo].[Classificacao]  WITH CHECK ADD  CONSTRAINT [FK_Classificacao_Grupos] FOREIGN KEY([GrupoId])
REFERENCES [dbo].[Grupos] ([GrupoId])
GO

ALTER TABLE [dbo].[Classificacao] CHECK CONSTRAINT [FK_Classificacao_Grupos]
GO

ALTER TABLE [dbo].[Classificacao]  WITH CHECK ADD  CONSTRAINT [FK_Classificacao_Selecoes] FOREIGN KEY([SelecaoId])
REFERENCES [dbo].[Selecoes] ([SelecaoId])
GO

ALTER TABLE [dbo].[Classificacao] CHECK CONSTRAINT [FK_Classificacao_Selecoes]
GO


