﻿Public Class FormMenu

    Dim grupoAtual As Integer = 1
    Dim selid As Integer
    Dim jgs As Integer
    Dim pts As Integer
    Dim vit As Integer
    Dim emp As Integer
    Dim der As Integer
    Dim gp As Integer
    Dim gc As Integer
    Dim sg As Integer
    Private contador As Integer = 0
    Private relacaoJogos As List(Of Jogos)
    Private tJogos As New Jogos
    Dim botao As Button
    Private RelatorioTitulo As String = ""
    Private paginaAtual As Integer = 1

    Private Sub CadastrosToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CadastrosToolStripMenuItem.Click
        My.Forms.FormGrupos.ShowDialog()
    End Sub

    Private Sub SeToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SeToolStripMenuItem.Click
        My.Forms.FormSelecoes.ShowDialog()
    End Sub

    Private Sub JOGADORESToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles JOGADORESToolStripMenuItem1.Click
        My.Forms.FormJogadores.ShowDialog()
    End Sub

    Private Sub SEDESToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles SEDESToolStripMenuItem1.Click
        My.Forms.FormSedes.ShowDialog()
    End Sub
    Private Sub btnGA_Click(sender As Object, e As EventArgs) Handles btnGA.Click, btnGB.Click, btnGC.Click, btnGD.Click, btnGE.Click, btnGF.Click, btnGG.Click, btnGH.Click, btnOitavas.Click, btnQuartas.Click, btnSemi.Click, btnFinal.Click


        botao = CType(sender, Button)

        Select Case botao.Name
            Case "btnGA"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 1
                preencheGrid(1, botao.Tag)
            Case "btnGB"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 2
                preencheGrid(2, botao.Tag)
            Case "btnGC"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 3
                preencheGrid(3, botao.Tag)
            Case "btnGD"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 4
                preencheGrid(4, botao.Tag)
            Case "btnGE"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 5
                preencheGrid(5, botao.Tag)
            Case "btnGF"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 6
                preencheGrid(6, botao.Tag)
            Case "btnGG"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 7
                preencheGrid(7, botao.Tag)
            Case "btnGH"
                grpJogos.Visible = True
                grpClassificacao.Visible = True
                btnClassificacao.Visible = True
                grupoAtual = 8
                preencheGrid(8, botao.Tag)
            Case "btnOitavas"
                My.Forms.Form_Oitavas.ShowDialog()
            Case "btnQuartas"
                My.Forms.Form_Quartas.ShowDialog()
            Case "btnSemi"
                My.Forms.Form_Semi.ShowDialog()
            Case "btnFinal"
                My.Forms.Form_Final.ShowDialog()
        End Select

    End Sub
    Private Sub preencheGrid(ByVal grupo As Integer, ByVal btn As String)

        grupoAtual = grupo
        grpJogos.Text = " Jogos - Grupo " & btn
        grpClassificacao.Text = " Classificacao - Grupo " & btn

        Dim lblDatas() As Label = New Label() {lblData1, lblData2, lblData3, lblData4, lblData5, lblData6}
        Dim lblHoras() As Label = New Label() {lblHora1, lblHora2, lblHora3, lblHora4, lblHora5, lblHora6}
        Dim lblSelecoes1() As Label = New Label() {lblSelecao11, lblSelecao12, lblSelecao13, lblSelecao14, lblSelecao15, lblSelecao16}
        Dim picBandeiras1() As PictureBox = New PictureBox() {picBandeiraSelecao11, picBandeiraSelecao12, picBandeiraSelecao13, picBandeiraSelecao14, picBandeiraSelecao15, picBandeiraSelecao16}
        Dim txtGol1s() As TextBox = New TextBox() {txtGol11, txtGol12, txtGol13, txtGol14, txtGol15, txtGol16}
        Dim txtGol2s() As TextBox = New TextBox() {txtGol21, txtGol22, txtGol23, txtGol24, txtGol25, txtGol26}
        Dim picBandeiras2() As PictureBox = New PictureBox() {picBandeiraSelecao21, picBandeiraSelecao22, picBandeiraSelecao23, picBandeiraSelecao24, picBandeiraSelecao25, picBandeiraSelecao26}
        Dim lblSelecoes2() As Label = New Label() {lblSelecao21, lblSelecao22, lblSelecao23, lblSelecao24, lblSelecao25, lblSelecao26}

        Dim i As Integer = 0

        Using ctx As New Copa2014Entities
            Try
                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupoAtual
                            Select jg

                If jogos.Count = 6 Then

                    For Each jogo In jogos
                        'atualiza os controles do formulário
                        lblDatas(i).Text = jogo.Data
                        lblHoras(i).Text = jogo.Hora.ToString
                        lblSelecoes1(i).Text = jogo.Selecoes.NomeSelecao
                        picBandeiras1(i).Image = exibeBandeira(jogo.Selecoes.Bandeira)
                        txtGol1s(i).Text = jogo.Gol1
                        txtGol2s(i).Text = jogo.Gol2
                        picBandeiras2(i).Image = exibeBandeira(jogo.Selecoes1.Bandeira)
                        lblSelecoes2(i).Text = jogo.Selecoes1.NomeSelecao
                        i = i + 1
                    Next
                Else
                    grpJogos.Visible = False
                    grpClassificacao.Visible = False
                    btnClassificacao.Visible = False
                    MessageBox.Show("Não há jogos cadastrados para este grupo. Cadastre os jogos antes...")
                End If

            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Sub atualizaJogos(ByVal grupo As Integer)

        Dim txtGol1s() As TextBox = New TextBox() {txtGol11, txtGol12, txtGol13, txtGol14, txtGol15, txtGol16}
        Dim txtGol2s() As TextBox = New TextBox() {txtGol21, txtGol22, txtGol23, txtGol24, txtGol25, txtGol26}

        grupoAtual = grupo
        Dim i As Integer = 0
        Using ctx As New Copa2014Entities
            Try
                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupoAtual
                            Select jg

                If jogos.Count = 6 Then
                    For Each jogo In jogos.ToList
                        'atualiza os controles do formulário
                        jogo.Gol1 = txtGol1s(i).Text
                        jogo.Gol2 = txtGol2s(i).Text
                        ctx.SaveChanges()
                        i = i + 1
                    Next
                Else
                    MessageBox.Show("Não há jogos cadastrados para este grupo. Cadastre os jogos antes...")
                End If
            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Sub atualizaClassificacao(ByVal grupoAtual As Integer)

        Using ctx As New Copa2014Entities

            Try
                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupoAtual
                            Select jg

                Dim selecoes = From sel In ctx.Selecoes
                       Where sel.GrupoId = grupoAtual
                       Select sel

                For Each selecao In selecoes.ToList()
                    selid = selecao.SelecaoId
                    'zera valores para inicio da contagem
                    pts = 0
                    sg = 0
                    gp = 0
                    gc = 0
                    jgs = 0
                    vit = 0
                    emp = 0
                    der = 0

                    For Each jogo In jogos.ToList
                        If jogo.SelecaoId1 = selid Then
                            'incrementa jogos
                            jgs = jgs + 1
                            'calcula vitoria , empates e derrotas
                            If jogo.Gol1 = jogo.Gol2 Then
                                emp = emp + 1
                                gp = gp + jogo.Gol1
                                gc = gc + jogo.Gol2
                            ElseIf jogo.Gol1 > jogo.Gol2 Then
                                vit = vit + 1
                                gp = gp + jogo.Gol1
                                gc = gc + jogo.Gol2
                            ElseIf jogo.Gol1 < jogo.Gol2 Then
                                der = der + 1
                                gp = gp + jogo.Gol1
                                gc = gc + jogo.Gol2
                            End If
                        ElseIf jogo.SelecaoId2 = selid Then
                            'incrementa jogos
                            jgs = jgs + 1
                            'calcula vitoria , empates e derrotas
                            If jogo.Gol1 = jogo.Gol2 Then
                                emp = emp + 1
                                gp = gp + jogo.Gol1
                                gc = gc + jogo.Gol2
                            ElseIf jogo.Gol1 > jogo.Gol2 Then
                                der = der + 1
                                gp = gp + jogo.Gol2
                                gc = gc + jogo.Gol1
                            ElseIf jogo.Gol1 < jogo.Gol2 Then
                                vit = vit + 1
                                gp = gp + jogo.Gol2
                                gc = gc + jogo.Gol1
                            End If
                        End If
                    Next
                    'calcula pontos e salgo de gols
                    pts = vit * 3 + emp * 1
                    sg = gp - gc
                    'atualiza classificacao
                    InserirAtualizarDadosClassificacao(grupoAtual, selid)
                Next
                'exibe classificacao
                exibeClassificacao(grupoAtual)
            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Function exibeBandeira(ByVal nomeArquivo As String) As Bitmap
        Try
            Dim bm As New Bitmap(nomeArquivo)
            Return bm
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Sub btnClassificacao_Click(sender As Object, e As EventArgs) Handles btnClassificacao.Click
        atualizaJogos(grupoAtual)
        atualizaClassificacao(grupoAtual)
        exibeClassificacao(grupoAtual)
    End Sub
    Private Sub btnInicio_Click(sender As Object, e As EventArgs) Handles btnInicio.Click
        grpClassificacao.Visible = False
        grpJogos.Visible = False
        btnClassificacao.Visible = False
    End Sub
    Private Sub exibeClassificacao(ByVal grupo As Integer)
        Using ctx As New Copa2014Entities
            Try
                dgvClassificacao.DataSource = Nothing
                Dim classificacao = From clsf In ctx.Classificacao
                                    Where clsf.GrupoId = grupoAtual
                                    Order By clsf.Pontos Descending, clsf.SaldoGols Descending, clsf.GolPro Descending
                                    Select clsf.Selecoes.NomeSelecao, clsf.Pontos, clsf.Jogos, clsf.Vitorias, clsf.Empates, clsf.Derrotas, clsf.GolPro, clsf.GolContra, clsf.SaldoGols

                dgvClassificacao.DataSource = classificacao.ToList
                formataGridView()

            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro:: ", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Sub InserirAtualizarDadosClassificacao(ByVal grupoId As Integer, ByVal selecaoid As Integer)

        Try
            Using ctx As New Copa2014Entities

                Dim classif = (From cla In ctx.Classificacao Where cla.SelecaoId = selecaoid).SingleOrDefault

                If IsNothing(classif) Then
                    Dim classificacao As New Classificacao
                    classificacao.SelecaoId = selecaoid
                    classificacao.GrupoId = grupoId
                    classificacao.Pontos = pts
                    classificacao.Jogos = jgs
                    classificacao.Vitorias = vit
                    classificacao.Empates = emp
                    classificacao.Derrotas = der
                    classificacao.GolPro = gp
                    classificacao.GolContra = gc
                    classificacao.SaldoGols = sg
                    ctx.Classificacao.Add(classificacao)
                    ctx.SaveChanges()
                Else
                    Try
                        classif.SelecaoId = selecaoid
                        classif.GrupoId = grupoId
                        classif.Pontos = pts
                        classif.Jogos = jgs
                        classif.Vitorias = vit
                        classif.Empates = emp
                        classif.Derrotas = der
                        classif.GolPro = gp
                        classif.GolContra = gc
                        classif.SaldoGols = sg
                        ctx.SaveChanges()
                    Catch ex As Exception
                        MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End Try
                End If

            End Using

        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir/Atualizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub formataGridView()

        With dgvClassificacao
            .AutoGenerateColumns = False
            .RowHeadersVisible = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera a cor das linhas alternadas no grid
            .RowsDefaultCellStyle.BackColor = Color.White
            .AlternatingRowsDefaultCellStyle.BackColor = Color.YellowGreen
            'altera o nome das colunas
            .Columns(0).HeaderText = "Classificação"
            .Columns(1).HeaderText = "P"
            .Columns(2).HeaderText = "J"
            .Columns(3).HeaderText = "V"
            .Columns(4).HeaderText = "E"
            .Columns(5).HeaderText = "D"
            .Columns(6).HeaderText = "GP"
            .Columns(7).HeaderText = "GC"
            .Columns(8).HeaderText = "SG"
            'largura colunas
            .Columns(0).Width = 150
            .Columns(1).Width = 50
            .Columns(2).Width = 50
            .Columns(3).Width = 50
            .Columns(4).Width = 50
            .Columns(5).Width = 50
            .Columns(6).Width = 50
            .Columns(7).Width = 50
            .Columns(8).Width = 50
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            ' exibe nulos formatados
            .DefaultCellStyle.NullValue = " - "
            'permite que o texto maior que célula não seja truncado
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
        End With

    End Sub
    Private Sub AFASEToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AFASEToolStripMenuItem.Click
        My.Forms.FormJogos.ShowDialog()
    End Sub

    Private Sub OITAVASToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OITAVASToolStripMenuItem.Click
        My.Forms.FormOitavas.ShowDialog()
    End Sub

    Private Sub QUARTASToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles QUARTASToolStripMenuItem.Click
        My.Forms.FormQuartas.ShowDialog()
    End Sub

    Private Sub SEMIFINALToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SEMIFINALToolStripMenuItem.Click
        My.Forms.FormSemi.ShowDialog()
    End Sub

    Private Sub FINALToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles FINALToolStripMenuItem.Click
        My.Forms.FormFinal.ShowDialog()
    End Sub

    Private Sub SOBREToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SOBREToolStripMenuItem.Click
        My.Forms.frmSobre.ShowDialog()
    End Sub

    Private Sub SIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SIRToolStripMenuItem.Click
        If (MessageBox.Show("Deseja encerrar o programa ? ", "Encerrar", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.Yes) Then
            Application.Exit()
        End If
    End Sub

    Private Sub btnImprimir_Click(sender As Object, e As EventArgs) Handles btnImprimir.Click
        'define o titulo do relatorio
        RelatorioTitulo = "Jogos do Grupo  - " & botao.Tag.ToString()
        'define os objetos printdocument e os eventos associados
        Dim pd As Printing.PrintDocument = New Printing.PrintDocument()

        'IMPORTANTE - definimos 3 eventos para tratar a impressão : PringPage, BeginPrint e EndPrint.
        AddHandler pd.PrintPage, New Printing.PrintPageEventHandler(AddressOf Me.pdRelatorios_PrintPage)
        AddHandler pd.BeginPrint, New Printing.PrintEventHandler(AddressOf Me.Begin_Print)
        AddHandler pd.EndPrint, New Printing.PrintEventHandler(AddressOf Me.End_Print)

        'define o objeto para visualizar a impressao
        Dim objPrintPreview As New PrintPreviewDialog
        Try
            'define o formulário como maximizado e com Zoom
            With objPrintPreview
                .Document = pd
                .WindowState = FormWindowState.Maximized
                .PrintPreviewControl.Zoom = 1
                .Text = "Jogos da Copa do Munso"
                .ShowDialog()
            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message.ToString())
        End Try
        'ImprimeJogos(grupoAtual)
    End Sub
    'A conexÆo e o DataReader ‚ aberto aqui
    Private Sub Begin_Print(ByVal sender As Object, ByVal e As Printing.PrintEventArgs)
        paginaAtual = 1
        contador = 0
    End Sub
    'Encerra a conexÆo e o DataReader
    Private Sub End_Print(ByVal sender As Object, ByVal byvale As Printing.PrintEventArgs)
        MessageBox.Show("Impressão Concluída.")
    End Sub
    Private Sub pdRelatorios_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        'Variaveis das linhas
        Dim LinhasPorPagina As Single = 0
        Dim PosicaoDaLinha As Single = 0
        Dim LinhaAtual As Integer = 0

        'Variaveis das margens
        Dim MargemEsq As Single = e.MarginBounds.Left
        Dim MargemSuperior As Single = e.MarginBounds.Top + 100
        Dim MargemDireita As Single = e.MarginBounds.Right
        Dim MargemInferior As Single = e.MarginBounds.Bottom

        Dim CanetaDaImpressora As New Pen(Color.Black, 1)

        'Variaveis das fontes
        Dim FonteNegrito As Font = Nothing
        Dim FonteTitulo As Font = Nothing
        Dim FonteSubTitulo As Font = Nothing
        Dim FonteRodape As Font = Nothing
        Dim FonteNormal As Font = Nothing

        'define efeitos em fontes
        FonteNegrito = New Font("Arial", 9, FontStyle.Bold)
        FonteTitulo = New Font("Arial", 15, FontStyle.Bold)
        FonteSubTitulo = New Font("Arial", 12, FontStyle.Bold)
        FonteRodape = New Font("Arial", 8)
        FonteNormal = New Font("Arial", 10)

        'define valores para linha atual e para linha da impressao
        LinhaAtual = 0

        Using ctx As New Copa2014Entities
            Try
                Dim jogos = From jg In ctx.Jogos
                               Where jg.GrupoId = grupoAtual
                               Select jg

                relacaoJogos = jogos.ToList()
            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message)
                Return
            End Try


            'Cabecalho
            e.Graphics.DrawLine(CanetaDaImpressora, MargemEsq, 60, MargemDireita, 60)
            e.Graphics.DrawLine(CanetaDaImpressora, MargemEsq, 160, MargemDireita, 160)
            'nome da empresa
            e.Graphics.DrawString("Copa do Mundo de 2014 - JcmSoft", FonteTitulo, Brushes.Blue, MargemEsq + 150, 80, New StringFormat())
            'Imagem
            e.Graphics.DrawImage(Image.FromFile(getCaminhoImagem() + "\maco.gif"), 100, 68)
            e.Graphics.DrawString(RelatorioTitulo, FonteSubTitulo, Brushes.Black, MargemEsq + 220, 120, New StringFormat())

            LinhasPorPagina = Convert.ToInt32(e.MarginBounds.Height / FonteNormal.GetHeight(e.Graphics) - 9)

            While (LinhaAtual < LinhasPorPagina And relacaoJogos.Count >= contador + 1)

                'obtem o valor da entidade
                tJogos = relacaoJogos.Item(contador)

                'obtem os valores das entidades e atribui as variaveis
                Dim jogoid As String = tJogos.JogoId
                Dim jogoLocal As String = tJogos.Locais.Endereco
                Dim jogoData As String = tJogos.Data.ToString()
                Dim jogoHora As String = tJogos.Hora.ToString()
                Dim jogoSelecao1 As String = tJogos.Selecoes.NomeSelecao.ToString()
                Dim jogoSelecao2 As String = tJogos.Selecoes1.NomeSelecao.ToString()

                'inicia a impressao
                PosicaoDaLinha = MargemSuperior + (LinhaAtual * FonteNormal.GetHeight(e.Graphics))

                'impressão dos dados
                e.Graphics.DrawString(jogoLocal, FonteNormal, Brushes.Black, MargemEsq, PosicaoDaLinha)
                e.Graphics.DrawString(jogoData, FonteNormal, Brushes.Black, MargemEsq + 100, PosicaoDaLinha)
                e.Graphics.DrawString(jogoHora, FonteNormal, Brushes.Black, MargemEsq + 300, PosicaoDaLinha)
                '------------------------
                e.Graphics.DrawString(jogoSelecao1, FonteNormal, Brushes.Black, MargemEsq + 250, PosicaoDaLinha + 20)
                e.Graphics.DrawString(" X ", FonteNormal, Brushes.Black, MargemEsq + 380, PosicaoDaLinha + 20)
                e.Graphics.DrawString(jogoSelecao2, FonteNormal, Brushes.Black, MargemEsq + 450, PosicaoDaLinha + 20)
                '
                'pula pagina
                LinhaAtual += 5
                contador += 1
            End While

            'Rodape
            e.Graphics.DrawLine(CanetaDaImpressora, MargemEsq, MargemInferior, MargemDireita, MargemInferior)
            e.Graphics.DrawString(System.DateTime.Now.ToString(), FonteRodape, Brushes.Black, MargemEsq, MargemInferior, New StringFormat())
            LinhaAtual += Convert.ToInt32(FonteNormal.GetHeight(e.Graphics))
            LinhaAtual += 1
            e.Graphics.DrawString("Pagina : " + paginaAtual.ToString, FonteRodape, Brushes.Black, MargemDireita - 50, MargemInferior, New StringFormat())

            'Incrementa o n£mero da pagina
            paginaAtual += 1

            'verifica se ainda existem páginas a imprimir
            If (relacaoJogos.Count > contador) Then
                e.HasMorePages = True
            Else
                e.HasMorePages = False
            End If
        End Using
    End Sub
    Public Shared Function getCaminhoImagem() As String
        Dim caminhoArquivo As String = Application.StartupPath
        If caminhoArquivo.IndexOf("\bin\Debug") <> -1 Then
            caminhoArquivo = caminhoArquivo.Replace("\bin\Debug", "")
        ElseIf caminhoArquivo.IndexOf("\bin\Release") <> -1 Then
            caminhoArquivo = caminhoArquivo.Replace("\bin\Release", "")
        End If
        Return caminhoArquivo + "\Imagens\"
    End Function
End Class