USE [Copa2014]
GO

/****** Object:  Table [dbo].[Jogadores]    Script Date: 05/06/2014 10:40:52 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

SET ANSI_PADDING ON
GO

CREATE TABLE [dbo].[Jogadores](
	[JogadorId] [int] IDENTITY(1,1) NOT NULL,
	[Nome] [nvarchar](50) NULL,
	[JogadorFoto] [varbinary](max) NULL,
	[SelecaoId] [int] NOT NULL,
 CONSTRAINT [PK_Jogadores] PRIMARY KEY CLUSTERED 
(
	[JogadorId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

ALTER TABLE [dbo].[Jogadores]  WITH CHECK ADD  CONSTRAINT [FK_Jogadores_Selecoes] FOREIGN KEY([SelecaoId])
REFERENCES [dbo].[Selecoes] ([SelecaoId])
GO

ALTER TABLE [dbo].[Jogadores] CHECK CONSTRAINT [FK_Jogadores_Selecoes]
GO


