USE [Copa2014]
GO

/****** Object:  Table [dbo].[Selecoes]    Script Date: 05/06/2014 10:41:26 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Selecoes](
	[SelecaoId] [int] IDENTITY(1,1) NOT NULL,
	[Nome] [nvarchar](50) NULL,
	[Bandeira] [nvarchar](150) NULL,
	[GrupoId] [int] NOT NULL,
 CONSTRAINT [PK_Selecoes] PRIMARY KEY CLUSTERED 
(
	[SelecaoId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[Selecoes]  WITH CHECK ADD  CONSTRAINT [FK_Selecoes_Grupos] FOREIGN KEY([GrupoId])
REFERENCES [dbo].[Grupos] ([GrupoId])
GO

ALTER TABLE [dbo].[Selecoes] CHECK CONSTRAINT [FK_Selecoes_Grupos]
GO


