USE [master]
GO

/****** Object:  Database [Copa2014]    Script Date: 05/06/2014 10:39:25 ******/
CREATE DATABASE [Copa2014]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'Copa2014', FILENAME = N'C:\Users\Mac\Copa2014.mdf' , SIZE = 4096KB , MAXSIZE = UNLIMITED, FILEGROWTH = 1024KB )
 LOG ON 
( NAME = N'Copa2014_log', FILENAME = N'C:\Users\Mac\Copa2014_log.ldf' , SIZE = 1024KB , MAXSIZE = 2048GB , FILEGROWTH = 10%)
GO

ALTER DATABASE [Copa2014] SET COMPATIBILITY_LEVEL = 110
GO

IF (1 = FULLTEXTSERVICEPROPERTY('IsFullTextInstalled'))
begin
EXEC [Copa2014].[dbo].[sp_fulltext_database] @action = 'enable'
end
GO

ALTER DATABASE [Copa2014] SET ANSI_NULL_DEFAULT OFF 
GO

ALTER DATABASE [Copa2014] SET ANSI_NULLS OFF 
GO

ALTER DATABASE [Copa2014] SET ANSI_PADDING OFF 
GO

ALTER DATABASE [Copa2014] SET ANSI_WARNINGS OFF 
GO

ALTER DATABASE [Copa2014] SET ARITHABORT OFF 
GO

ALTER DATABASE [Copa2014] SET AUTO_CLOSE OFF 
GO

ALTER DATABASE [Copa2014] SET AUTO_CREATE_STATISTICS ON 
GO

ALTER DATABASE [Copa2014] SET AUTO_SHRINK OFF 
GO

ALTER DATABASE [Copa2014] SET AUTO_UPDATE_STATISTICS ON 
GO

ALTER DATABASE [Copa2014] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO

ALTER DATABASE [Copa2014] SET CURSOR_DEFAULT  GLOBAL 
GO

ALTER DATABASE [Copa2014] SET CONCAT_NULL_YIELDS_NULL OFF 
GO

ALTER DATABASE [Copa2014] SET NUMERIC_ROUNDABORT OFF 
GO

ALTER DATABASE [Copa2014] SET QUOTED_IDENTIFIER OFF 
GO

ALTER DATABASE [Copa2014] SET RECURSIVE_TRIGGERS OFF 
GO

ALTER DATABASE [Copa2014] SET  DISABLE_BROKER 
GO

ALTER DATABASE [Copa2014] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO

ALTER DATABASE [Copa2014] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO

ALTER DATABASE [Copa2014] SET TRUSTWORTHY OFF 
GO

ALTER DATABASE [Copa2014] SET ALLOW_SNAPSHOT_ISOLATION OFF 
GO

ALTER DATABASE [Copa2014] SET PARAMETERIZATION SIMPLE 
GO

ALTER DATABASE [Copa2014] SET READ_COMMITTED_SNAPSHOT OFF 
GO

ALTER DATABASE [Copa2014] SET HONOR_BROKER_PRIORITY OFF 
GO

ALTER DATABASE [Copa2014] SET RECOVERY SIMPLE 
GO

ALTER DATABASE [Copa2014] SET  MULTI_USER 
GO

ALTER DATABASE [Copa2014] SET PAGE_VERIFY CHECKSUM  
GO

ALTER DATABASE [Copa2014] SET DB_CHAINING OFF 
GO

ALTER DATABASE [Copa2014] SET FILESTREAM( NON_TRANSACTED_ACCESS = OFF ) 
GO

ALTER DATABASE [Copa2014] SET TARGET_RECOVERY_TIME = 0 SECONDS 
GO

ALTER DATABASE [Copa2014] SET  READ_WRITE 
GO


